( function ($) {
	'use strict';
	$(window).load(function () {
		var configip,
			selectorip,
			selectedIpglobalarr,
			selectedDomainglobalarr,
			arrIpList,
			arrDomainList,
			selectedDomainArray,
			i,
			j,
			k,
			m,
			n,
			o,
			p,
			q,
			r,
			s,
			t,
			z,
			ipString,
			ipaddress,
			configstate,
			selectorstate,
			selectedStateArray,
			selectedStateglobalarr,
			arrStateList,
			stateString,
			configcountry,
			selectorcountry,
			selectedCountryArray,
			selectedCountryglobalarr,
			arrCountryList,
			countryString,
			userroleString,
			selectedUserroleglobalarr,
			selectoruserrole,
			selectedUserroleArray,
			configuserrole,
			userrole,
			zoneString,
			selectedZoneglobalarr,
			selectedZoneArray,
			selectorzone,
			configzone,
			zone,
			zipString,
			selectedZipglobalarr,
			selectedZipArray,
			selectorzip,
			configzip,
			email,
			emailString,
			selectedEmailglobalarr,
			selectedEmailArray,
			selectoremail,
			configemail,
			userAgent,
			arrEmailList,
			userAgentString,
			selectedUserAgentglobalarr,
			selectedUserAgentArray,
			selectoruseragent,
			configuseragent,
			lastName,
			arrLastNamelist,
			lastNameString,
			selectedLastNameglobalarr,
			selectedLastNameArray,
			selectorlastname,
			configlastname,
			fistName,
			firstNameString,
			selectedFirstNameglobalarr,
			selectedFirstNameArray,
			selectorfirstname,
			configfirstname,
			phone,
			arrFirstNameList,
			phoneString,
			selectedPhoneglobalarr,
			selectedPhoneArray,
			selectorphone,
			configphone,
			domain,
			arrPhoneList,
			domainString,
			selectordomain,
			configdomain,
			state,
			country,
			arrZipList,
			configdomainext,
			selectordomainext,
			selectedDomainextArray,
			selectedDomainextglobalarr,
			domainext,
			arrDomainextList,
			domainextString,
			selectedIpArray,
			localize_json_output;
		localize_json_output = $.parseJSON($('input[name="localize_json_output"]').val());
		$('body').on('click', '#wcblu_reset_settings', function () {
			ajaxindicatorstart('Please wait..!!');
			jQuery.ajax({
				url: adminajax.ajaxurl,
				type: 'post',
				data: {
					action: 'wcblu_reset_settings',
				},
				success: function (html) {
					location.reload(true);
				},
			});
		});

		$('body').on('click', '.wcblu_export_settings', function(e){
			e.preventDefault();
			var action = $("input[name='wcblu_export_action']").val();
			var $this = jQuery(this);
			ajaxindicatorstart('Please wait..!!');
			jQuery.ajax({
				url: adminajax.ajaxurl,
				type: 'post',
				data: {
					action: action,
					nonce:  adminajax.nonce,
				},
				success: function (responce) {

					jQuery(".responce_message").remove();
					var message = $('<span/>', { class: 'responce_message success', text: responce.message }).insertAfter('.wcblu_export_settings');

					var dynamic_download = $('<a />', { href: responce.file, download: responce.filename });
					$("body").append(dynamic_download);
					dynamic_download[0].click();
					$("body").remove(dynamic_download);

					setTimeout(function(){
						message.remove();
					}, 5000);
					
					ajaxindicatorstop();
				},
			});
		});

		$('body').on('click', '.wcblu_import_setting', function(e){
			e.preventDefault();
			var action = $("input[name='wcblu_import_action']").val();
			var json_file = $('input[name="import_file"]');
			jQuery(".responce_message").remove();

			if( json_file.val() == ''){
				$('<span/>', { class: 'responce_message error', text: adminajax.importError.exmptyFile }).insertAfter('.wcblu_import_setting');
				return false;
			}
			var ext = json_file.val().split('.').pop().toLowerCase();
			if($.inArray(ext, ['json']) == -1) {
				json_file.val('');
				$('<span/>', { class: 'responce_message error', text: adminajax.importError.invalidFile }).insertAfter('.wcblu_import_setting');
				return false;
			}
			var $this = jQuery(this);
			var dataImport = new FormData();
			dataImport.append('import_file', json_file[0].files[0]);
			dataImport.append('nonce', adminajax.nonce);
			dataImport.append('action', action);
			ajaxindicatorstart('Please wait..!!');
			jQuery.ajax({
				url: adminajax.ajaxurl,
				type: 'post',
				processData: false,
				contentType: false,
				cache: false,
				data: dataImport,
				success: function (responce) {

					jQuery(".responce_message").remove();
					json_file.val('');
					if(responce.success){
						var message = $('<span/>', { class: 'responce_message success', text: responce.message }).insertAfter('.wcblu_import_setting');
					} else {
						var message = $('<span/>', { class: 'responce_message error', text: responce.message }).insertAfter('.wcblu_import_setting');
					}

					setTimeout(function(){
						message.remove();
					}, 5000);
					
					ajaxindicatorstop();
				},
			});
		});
		
		$('body').on('click', '#wc_enb_ext_bl', function () {
			if ($(this).is(':checked')) {
				$(this).attr('value', '1');
			} else {
				$(this).attr('value', '0');
			}
		});
		
		$('body').on('click', '#wc_user_register_type', function () {
			if ($(this).is(':checked')) {
				$(this).attr('value', '1');
			} else {
				$(this).attr('value', '0');
			}
		});
		
		$('body').on('click', '#wc_user_place_order_type', function () {
			if ($(this).is(':checked')) {
				$(this).attr('value', '1');
			} else {
				$(this).attr('value', '0');
			}
		});
		
		// Chosen IP Address Start
		configip = {
			'.chosen-select-ip': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectorip in configip) {
			$(selectorip).chosen(configip[selectorip]);
		}
		
		selectedIpArray = localize_json_output.getIpOption.ipaddressarray;
		selectedIpArray = $.parseJSON(selectedIpArray);
		selectedIpglobalarr = [];
		arrIpList = [];
		for (i in selectedIpArray) {
			selectedIpglobalarr.push(selectedIpArray[i]);
		}
		
		ipString = '';
		ipString = selectedIpglobalarr.join(',');
		
		if ('' != ipString) {
			$.each(ipString.split(','), function (i, e) {
				arrIpList.push(e);
				$('#ip_address option[value=\'' + e + '\']').prop('selected', true);
				$('#ip_address').trigger('chosen:updated');
			});
		}
		
		//Check that entered only number allow in IP address.
		$('#ip_address_chosen ul.chosen-choices li.search-field input').keypress(function (event) {
			
			if (8 != event.which && isNaN(String.fromCharCode(event.which)) && 46 != event.which && 45 != event.which) {
				event.preventDefault(); //stop character from entering input
			}
			return;
		});
		
		$('body').on('keyup', '#ip_address_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var ip,
				valid;
			
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					ip = $(this).val();
				}
				if (186 == c) {
					ip = $(this).val().replace(';', '');
				}
				if (59 == c) {
					ip = $(this).val().replace(';', '');
				}
				if (188 == c) {
					ip = $(this).val().replace(',', '');
				}
				valid = ValidateIPaddress(ip);
				if ('' != ip && 'yes' == valid && -1 == $.inArray(ip, arrIpList)) {
					
					//add new first name in array
					arrIpList.push(ip);
					$('<option/>', { value: ip, text: ip }).appendTo('#ip_address');
					$('#ip_address option[value=\'' + ip + '\']').prop('selected', true);
					$('#ip_address').trigger('chosen:updated');
				} else {
					$('#ip_address').trigger('chosen:updated');
				}
			}
		});
		
		$('body').on('blur', '#ip_address_chosen ul.chosen-choices li.search-field input', function (evt) {
			var ip = $(this).val().replace(',', '');
			var valid = ValidateIPaddress(ip);
			if ('' != ip && 'yes' == valid && -1 == $.inArray(ip, arrIpList)) {
				
				//add new first name in array
				arrIpList.push(ip);
				$('<option/>', { value: ip, text: ip }).appendTo('#ip_address');
				$('#ip_address option[value=\'' + ip + '\']').prop('selected', true);
				$('#ip_address').trigger('chosen:updated');
			} else {
				$('#ip_address').trigger('chosen:updated');
			}
		});
		
		ipaddress = [];
		
		// Chosen IP Address End
		
		// Chosen State Start
		configstate = {
			'.chosen-select-state': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectorstate in configstate) {
			$(selectorstate).chosen(configstate[selectorstate]);
		}
		
		selectedStateArray = localize_json_output.getStateOption.statearray;
		selectedStateArray = $.parseJSON(selectedStateArray);
		selectedStateglobalarr = [];
		arrStateList = [];
		for (k in selectedStateArray) {
			selectedStateglobalarr.push(selectedStateArray[k]);
		}
		
		stateString = '';
		stateString = selectedStateglobalarr.join(',');
		
		if ('' != stateString) {
			$.each(stateString.split(','), function (i, e) {
				arrStateList.push(e);
				$('#state option[value=\'' + e + '\']').prop('selected', true);
				$('#state').trigger('chosen:updated');
			});
		}
		
		$('body').on('keyup', '#state_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var state;
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					state = $(this).val();
				}
				if (186 == c) {
					state = $(this).val().replace(';', '');
				}
				if (59 == c) {
					state = $(this).val().replace(';', '');
				}
				if (188 == c) {
					state = $(this).val().replace(',', '');
				}
				if ('' != state && -1 == $.inArray(state, arrStateList)) {
					
					//add new first name in array
					arrStateList.push(state);
					$('<option/>', { value: state, text: state }).appendTo('#state');
					$('#state option[value=\'' + state + '\']').prop('selected', true);
					$('#state').trigger('chosen:updated');
				} else {
					$('#state').trigger('chosen:updated');
				}
			}
		});
		
		$('body').on('blur', '#state_chosen ul.chosen-choices li.search-field input', function () {
			var state = $(this).val().replace(',', '');
			
			//var valid = ValidateState( state );
			if ('' != state && -1 == $.inArray(state, arrStateList)) {
				
				//add new first name in array
				arrStateList.push(state);
				$('<option/>', { value: state, text: state }).appendTo('#state');
				$('#state option[value=\'' + state + '\']').prop('selected', true);
				$('#state').trigger('chosen:updated');
			} else {
				$('#state').trigger('chosen:updated');
			}
		});
		
		state = [];
		// Chosen State End

		// Chosen Country Start
		configcountry = {
			'.chosen-select-country': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectorcountry in configcountry) {
			$(selectorcountry).chosen(configcountry[selectorcountry]);
		}

		selectedCountryArray = localize_json_output.getCountryOption.countryarray;
		selectedCountryArray = $.parseJSON(selectedCountryArray);
		selectedCountryglobalarr = [];
		arrCountryList = [];
		for (k in selectedCountryArray) {
			selectedCountryglobalarr.push(selectedCountryArray[k]);
		}
		
		countryString = '';
		countryString = selectedCountryglobalarr.join(',');
		if ('' != countryString) {
			$.each(countryString.split(','), function (i, e) {
				arrCountryList.push(e);
				$('#country option[value=\'' + e + '\']').prop('selected', true);
				$('#country').trigger('chosen:updated');
			});
		}

		$('body').on('keyup', '#country_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var country;
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					country = $(this).val();
				}
				if (186 == c) {
					country = $(this).val().replace(';', '');
				}
				if (59 == c) {
					country = $(this).val().replace(';', '');
				}
				if (188 == c) {
					country = $(this).val().replace(',', '');
				}
				// if ('' != country && -1 == $.inArray(country, arrCountryList)) {
					
				// 	//add new first name in array
				// 	arrCountryList.push(country);
				// 	$('<option/>', { value: country, text: country }).appendTo('#country');
				// 	$('#country option[value=\'' + country + '\']').prop('selected', true);
				// 	$('#country').trigger('chosen:updated');
				// } else {
				// 	$('#country').trigger('chosen:updated');
				// }
			}
		});
		
		// $('body').on('blur', '#country_chosen ul.chosen-choices li.search-field input', function () {
		// 	var country = $(this).val().replace(',', '');
			
		// 	//var valid = ValidateCountry( country );
		// 	if ('' != country && -1 == $.inArray(country, arrCountryList)) {
				
		// 		//add new first name in array
		// 		arrCountryList.push(country);
		// 		$('<option/>', { value: country, text: country }).appendTo('#country');
		// 		$('#country option[value=\'' + country + '\']').prop('selected', true);
		// 		$('#country').trigger('chosen:updated');
		// 	} else {
		// 		$('#country').trigger('chosen:updated');
		// 	}
		// });
		
		country = [];
		// Chosen Country End

		// Chosen Domain Start
		configdomain = {
			'.chosen-select-domain': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectordomain in configdomain) {
			$(selectordomain).chosen(configdomain[selectordomain]);
		}
		
		selectedDomainArray = localize_json_output.getDomainOption.domainarray;
		selectedDomainArray = $.parseJSON(selectedDomainArray);
		selectedDomainglobalarr = [];
		arrDomainList = [];
		for (j in selectedDomainArray) {
			selectedDomainglobalarr.push(selectedDomainArray[j]);
		}
		
		domainString = '';
		domainString = selectedDomainglobalarr.join(',');
		
		if ('' != domainString) {
			$.each(domainString.split(','), function (i, e) {
				
				//store all new domain in array
				arrDomainList.push(e);
				$('#domain option[value=\'' + e + '\']').prop('selected', true);
				$('#domain').trigger('chosen:updated');
			});
		}
		
		$('body').on('keyup', '#domain_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var domain;
			
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					domain = $(this).val();
				}
				if (186 == c) {
					domain = $(this).val().replace(';', '');
				}
				if (59 == c) {
					domain = $(this).val().replace(';', '');
				}
				if (188 == c) {
					domain = $(this).val().replace(',', '');
				}
				if ('' != domain && -1 == $.inArray(domain, arrDomainList)) {
					
					arrDomainList.push(domain);
					$('<option/>', { value: domain, text: domain }).appendTo('#domain');
					$('#domain option[value=\'' + domain + '\']').prop('selected', true);
					$('#domain').trigger('chosen:updated');
				} else {
					$('#domain').trigger('chosen:updated');
				}
			}
		});
		
		$('body').on('blur', '#domain_chosen ul.chosen-choices li.search-field input', function () {
			var domain = $(this).val().replace(',', '');
			if ('' != domain && -1 == $.inArray(domain, arrDomainList)) {
				arrDomainList.push(domain);
				$('<option/>', { value: domain, text: domain }).appendTo('#domain');
				$('#domain option[value=\'' + domain + '\']').prop('selected', true);
				$('#domain').trigger('chosen:updated');
			} else {
				$('#domain').trigger('chosen:updated');
			}
		});
		
		domain = [];
		
		configdomainext = {
			'.chosen-select-domain-ext': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectordomainext in configdomainext) {
			$(selectordomainext).chosen(configdomainext[selectordomainext]);
		}
		selectedDomainextArray = localize_json_output.getDomainextOption.domainextarray;
		selectedDomainextArray = $.parseJSON(selectedDomainextArray);
		selectedDomainextglobalarr = [];
		arrDomainextList = [];
		for (z in selectedDomainextArray) {
			selectedDomainextglobalarr.push(selectedDomainextArray[z]);
		}
		
		domainextString = '';
		domainextString = selectedDomainextglobalarr.join(',');
		
		if ('' != domainextString) {
			$.each(domainextString.split(','), function (i, e) {
				
				//store all new domain ext in array
				arrDomainextList.push(e);
				$('#domainext option[value=\'' + e + '\']').prop('selected', true);
				$('#domainext').trigger('chosen:updated');
			});
		}
		
		$('body').on('keyup', '#domainext_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var domainext;
			
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					domainext = $(this).val();
				}
				if (186 == c) {
					domainext = $(this).val().replace(';', '');
				}
				if (59 == c) {
					domainext = $(this).val().replace(';', '');
				}
				if (188 == c) {
					domainext = $(this).val().replace(',', '');
				}
				if ('' != domainext && -1 == $.inArray(domainext, arrDomainextList)) {
					
					arrDomainextList.push(domainext);
					$('<option/>', { value: domainext, text: domainext }).appendTo('#domainext');
					$('#domainext option[value=\'' + domainext + '\']').prop('selected', true);
					$('#domainext').trigger('chosen:updated');
				} else {
					$('#domainext').trigger('chosen:updated');
				}
			}
		});
		
		$('body').on('blur', '#domainext_chosen ul.chosen-choices li.search-field input', function () {
			var domainext = $(this).val().replace(',', '');
			if ('' != domainext && -1 == $.inArray(domainext, arrDomainextList)) {
				arrDomainextList.push(domainext);
				$('<option/>', { value: domainext, text: domainext }).appendTo('#domainext');
				$('#domainext option[value=\'' + domainext + '\']').prop('selected', true);
				$('#domainext').trigger('chosen:updated');
			} else {
				$('#domainext').trigger('chosen:updated');
			}
		});
		
		domainext = [];
		// Chosen Domain End
		
		// Chosen Phone Start
		configphone = {
			'.chosen-select-phone': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectorphone in configphone) {
			$(selectorphone).chosen(configphone[selectorphone]);
		}
		
		selectedPhoneArray = localize_json_output.getPhoneOption.phonearray;
		selectedPhoneArray = $.parseJSON(selectedPhoneArray);
		selectedPhoneglobalarr = [];
		for (m in selectedPhoneArray) {
			selectedPhoneglobalarr.push(selectedPhoneArray[m]);
		}
		
		phoneString = '';
		phoneString = selectedPhoneglobalarr.join(',');
		
		//define first name list array for duplicate entry checking purpose
		arrPhoneList = [];
		
		if ('' != phoneString) {
			$.each(phoneString.split(','), function (i, e) {
				
				//store all new phones
				arrPhoneList.push(e);
				$('#phone option[value=\'' + e + '\']').prop('selected', true);
				$('#phone').trigger('chosen:updated');
			});
		}
		
		//Check that entered only number allow in Phone address.
		$('#phone_chosen ul.chosen-choices li.search-field input').keypress(function (event) {
			if (8 != event.which && isNaN(String.fromCharCode(event.which)) && 43 != event.which) {
				event.preventDefault(); //stop character from entering input
			}
			return;
		});
		
		$('body').on('keyup', '#phone_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var phone;
			
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					phone = $(this).val();
				}
				if (186 == c) {
					phone = $(this).val().replace(';', '');
				}
				if (59 == c) {
					phone = $(this).val().replace(';', '');
				}
				if (188 == c) {
					phone = $(this).val().replace(',', '');
				}
				
				//var valid = ValidateIPaddress(ip);
				// check that, first name exist or not if does not exist then return -1
				if ('' != phone && -1 == $.inArray(phone, arrPhoneList)) {
					
					//add new first name in array
					arrPhoneList.push(phone);
					$('<option/>', { value: phone, text: phone }).appendTo('#phone');
					$('#phone option[value=\'' + phone + '\']').prop('selected', true);
					$('#phone').trigger('chosen:updated');
				} else {
					$('#phone').trigger('chosen:updated');
				}
			}
		});
		
		$('body').on('blur', '#phone_chosen ul.chosen-choices li.search-field input', function () {
			var phone = $(this).val().replace(',', '');
			
			// check that, first name exist or not if does not exist then return -1
			if ('' != phone && -1 == $.inArray(phone, arrPhoneList)) {
				
				//add new first name in array
				arrPhoneList.push(phone);
				$('<option/>', { value: phone, text: phone }).appendTo('#phone');
				$('#phone option[value=\'' + phone + '\']').prop('selected', true);
				$('#phone').trigger('chosen:updated');
			} else {
				$('#phone').trigger('chosen:updated');
			}
		});
		
		phone = [];
		// Chosen Phone End
		
		// Chosen first name Start
		configfirstname = {
			'.chosen-select-first-name': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectorfirstname in configfirstname) {
			$(selectorfirstname).chosen(configfirstname[selectorfirstname]);
		}
		
		selectedFirstNameArray = localize_json_output.getFirstNameOption.firstnamearray;
		selectedFirstNameArray = $.parseJSON(selectedFirstNameArray);
		selectedFirstNameglobalarr = [];
		for (n in selectedFirstNameArray) {
			selectedFirstNameglobalarr.push(selectedFirstNameArray[n]);
		}
		
		firstNameString = '';
		firstNameString = selectedFirstNameglobalarr.join(',');
		
		//define first name list array for duplicate entry checking purpose
		arrFirstNameList = [];
		if ('' != firstNameString) {
			$.each(firstNameString.split(','), function (i, e) {
				
				//add all first names in array
				arrFirstNameList.push(e);
				$('#first_name option[value=\'' + e + '\']').prop('selected', true);
				$('#first_name').trigger('chosen:updated');
			});
		}
		
		$('body').on('keyup', '#first_name_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var firstName;
			
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					fistName = $(this).val();
				}
				if (186 == c) {
					fistName = $(this).val().replace(';', '');
				}
				if (59 == c) {
					fistName = $(this).val().replace(';', '');
				}
				if (188 == c) {
					fistName = $(this).val().replace(',', '');
				}
				
				// check that, first name exist or not if does not exist then return -1
				if ('' != fistName && -1 == $.inArray(fistName, arrFirstNameList)) {
					
					//add new first name in array
					arrFirstNameList.push(fistName);
					$('<option/>', { value: fistName, text: fistName }).appendTo('#first_name');
					$('#first_name option[value=\'' + fistName + '\']').prop('selected', true);
					$('#first_name').trigger('chosen:updated');
				} else {
					
					//reset the last name
					$('#first_name').trigger('chosen:updated');
				}
			}
		});
		
		$('body').on('blur', '#first_name_chosen ul.chosen-choices li.search-field input', function () {
			var fistName = $(this).val().replace(',', '');
			
			// check that, first name exist or not if does not exist then return -1
			if ('' != fistName && -1 == $.inArray(fistName, arrFirstNameList)) {
				arrFirstNameList.push(fistName);
				$('<option/>', { value: fistName, text: fistName }).appendTo('#first_name');
				$('#first_name option[value=\'' + fistName + '\']').prop('selected', true);
				$('#first_name').trigger('chosen:updated');
			} else {
				
				//reset the last name
				$('#first_name').trigger('chosen:updated');
			}
		});
		
		fistName = [];
		
		// Chosen first name End
		
		// Chosen last name Start
		configlastname = {
			'.chosen-select-last-name': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectorlastname in configlastname) {
			$(selectorlastname).chosen(configlastname[selectorlastname]);
		}
		
		selectedLastNameArray = localize_json_output.getLastNameOption.lastnamearray;
		selectedLastNameArray = $.parseJSON(selectedLastNameArray);
		selectedLastNameglobalarr = [];
		
		//define first name list array for duplicate entry checking purpose
		arrLastNamelist = [];
		for (o in selectedLastNameArray) {
			selectedLastNameglobalarr.push(selectedLastNameArray[o]);
		}
		
		lastNameString = '';
		lastNameString = selectedLastNameglobalarr.join(',');
		
		if ('' != lastNameString) {
			$.each(lastNameString.split(','), function (i, e) {
				
				//add all first names in array
				arrLastNamelist.push(e);
				$('#last_name option[value=\'' + e + '\']').prop('selected', true);
				$('#last_name').trigger('chosen:updated');
			});
		}
		
		$('body').on('keyup', '#last_name_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var lastName;
			
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					lastName = $(this).val();
				}
				if (186 == c) {
					lastName = $(this).val().replace(';', '');
				}
				if (59 == c) {
					lastName = $(this).val().replace(';', '');
				}
				if (188 == c) {
					lastName = $(this).val().replace(',', '');
				}
				
				// check that, first name exist or not if does not exist then return -1
				if ('' != lastName && -1 == $.inArray(lastName, arrLastNamelist)) {
					arrLastNamelist.push(lastName);
					$('<option/>', { value: lastName, text: lastName }).appendTo('#last_name');
					$('#last_name option[value=\'' + lastName + '\']').prop('selected', true);
					$('#last_name').trigger('chosen:updated');
				} else {
					
					//reset the last name
					$('#last_name').trigger('chosen:updated');
				}
			}
		});
		
		$('body').on('blur', '#last_name_chosen ul.chosen-choices li.search-field input', function () {
			var lastName = $(this).val().replace(',', '');
			
			// check that, first name exist or not if does not exist then return -1
			if ('' != lastName && -1 == $.inArray(lastName, arrLastNamelist)) {
				arrLastNamelist.push(lastName);
				$('<option/>', { value: lastName, text: lastName }).appendTo('#last_name');
				$('#last_name option[value=\'' + lastName + '\']').prop('selected', true);
				$('#last_name').trigger('chosen:updated');
			} else {
				
				//reset the last name
				$('#last_name').trigger('chosen:updated');
			}
		});
		
		lastName = [];
		
		// Chosen Last name End
		
		// Chosen User Agent Start
		configuseragent = {
			'.chosen-select-user-agent': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectoruseragent in configuseragent) {
			$(selectoruseragent).chosen(configuseragent[selectoruseragent]);
		}
		selectedUserAgentArray = localize_json_output.getUserAgentOption.useragentarray;
		selectedUserAgentArray = $.parseJSON(selectedUserAgentArray);
		selectedUserAgentglobalarr = [];
		for (p in selectedUserAgentArray) {
			selectedUserAgentglobalarr.push(selectedUserAgentArray[p]);
		}
		userAgentString = '';
		userAgentString = selectedUserAgentglobalarr.join(',');
		if ('' != userAgentString) {
			$.each(userAgentString.split(','), function (i, e) {
				$('#user_agent option[value=\'' + e + '\']').prop('selected', true);
				$('#user_agent').trigger('chosen:updated');
			});
		}
		
		userAgent = [];
		
		// Chosen User Agent End
		
		// Chosen email Start
		configemail = {
			'.chosen-select-email': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectoremail in configemail) {
			$(selectoremail).chosen(configemail[selectoremail]);
		}
		
		selectedEmailArray = localize_json_output.getEmailOption.emailarray;
		selectedEmailArray = $.parseJSON(selectedEmailArray);
		selectedEmailglobalarr = [];
		arrEmailList = [];
		for (q in selectedEmailArray) {
			selectedEmailglobalarr.push(selectedEmailArray[q]);
		}
		
		emailString = '';
		emailString = selectedEmailglobalarr.join(',');
		
		if ('' != emailString) {
			$.each(emailString.split(','), function (i, e) {
				arrEmailList.push(e);
				$('#email option[value=\'' + e + '\']').prop('selected', true);
				$('#email').trigger('chosen:updated');
			});
		}
		
		$('body').on('keyup', '#email_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var valid,
				email;
			
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					email = $(this).val();
				}
				if (186 == c) {
					email = $(this).val().replace(';', '');
				}
				if (59 == c) {
					email = $(this).val().replace(';', '');
				}
				if (188 == c) {
					email = $(this).val().replace(',', '');
				}
				valid = ValidateEmail(email);
				
				// check that, first name exist or not if does not exist then return -1
				if ('' != email && 'yes' == valid && -1 == $.inArray(email, arrEmailList)) {
					arrEmailList.push(email);
					$('<option/>', { value: email, text: email }).appendTo('#email');
					$('#email option[value=\'' + email + '\']').prop('selected', true);
					$('#email').trigger('chosen:updated');
				} else {
					$('#email').trigger('chosen:updated');
				}
			}
		});
		
		$('body').on('blur', '#email_chosen ul.chosen-choices li.search-field input', function () {
			var email = $(this).val().replace(',', '');
			
			var valid = ValidateEmail(email);
			
			// check that, first name exist or not if does not exist then return -1
			if ('' != email && 'yes' == valid && -1 == $.inArray(email, arrEmailList)) {
				arrEmailList.push(email);
				$('<option/>', { value: email, text: email }).appendTo('#email');
				$('#email option[value=\'' + email + '\']').prop('selected', true);
				$('#email').trigger('chosen:updated');
			} else {
				$('#email').trigger('chosen:updated');
			}
		});
		
		email = [];
		
		// Chosen email End
		
		// Chosen Zip Start
		configzip = {
			'.chosen-select-zip': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectorzip in configzip) {
			$(selectorzip).chosen(configzip[selectorzip]);
		}
		
		selectedZipArray = localize_json_output.getZipOption.ziparray;
		selectedZipArray = $.parseJSON(selectedZipArray);
		selectedZipglobalarr = [];
		arrZipList = [];
		for (r in selectedZipArray) {
			selectedZipglobalarr.push(selectedZipArray[r]);
		}
		
		zipString = '';
		zipString = selectedZipglobalarr.join(',');
		
		if ('' != zipString) {
			$.each(zipString.split(','), function (i, e) {
				$('#zip option[value=\'' + e + '\']').prop('selected', true);
				$('#zip').trigger('chosen:updated');
			});
		}
		
		$('body').on('keyup', '#zip_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var valid,
				zip;
			
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					zip = $(this).val();
				}
				if (186 == c) {
					zip = $(this).val().replace(';', '');
				}
				if (59 == c) {
					zip = $(this).val().replace(';', '');
				}
				if (188 == c) {
					zip = $(this).val().replace(',', '');
				}
				
				/*valid = ValidateZip(zip);*/
				if ('' != zip && -1 == $.inArray(zip, arrZipList)) {
					
					//add new first name in array
					arrZipList.push(zip);
					$('<option/>', { value: zip, text: zip }).appendTo('#zip');
					$('#zip option[value=\'' + zip + '\']').prop('selected', true);
					$('#zip').trigger('chosen:updated');
				}
			}
		});
		
		$('body').on('blur', '#zip_chosen ul.chosen-choices li.search-field input', function () {
			var zip = $(this).val().replace(',', '');
			
			/*var valid = ValidateZip(zip);*/
			if ('' != zip && -1 == $.inArray(zip, arrZipList)) {
				
				//add new first name in array
				arrZipList.push(zip);
				$('<option/>', { value: zip, text: zip }).appendTo('#zip');
				$('#zip option[value=\'' + zip + '\']').prop('selected', true);
				$('#zip').trigger('chosen:updated');
			}
		});
		
		zone = [];
		
		// chosen zone start
		
		// Chosen Zip Start
		configzone = {
			'.chosen-select-zone': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectorzone in configzone) {
			$(selectorzone).chosen(configzone[selectorzone]);
		}
		selectedZoneArray = localize_json_output.getZoneOption.zonearray;
		selectedZoneArray = $.parseJSON(selectedZoneArray);
		
		selectedZoneglobalarr = [];
		for (s in selectedZoneArray) {
			selectedZoneglobalarr.push(selectedZoneArray[s]);
		}
		zoneString = '';
		zoneString = selectedZoneglobalarr.join(',');
		if ('' != zoneString) {
			$.each(zoneString.split(','), function (i, e) {
				$('#shipping_zone option[value=\'' + e + '\']').prop('selected', true);
				$('#shipping_zone').trigger('chosen:updated');
			});
		}
		$('body').on('keyup', '#shipping_zone_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var valid,
				zone;
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					zone = $(this).val();
				}
				if (186 == c) {
					zone = $(this).val().replace(';', '');
				}
				if (59 == c) {
					zone = $(this).val().replace(';', '');
				}
				if (188 == c) {
					zone = $(this).val().replace(',', '');
				}
				valid = ValidateZone(zone);
				if ('yes' == valid) {
					$('<option/>', { value: zone, text: zone }).appendTo('#shipping_zone');
					$('#shipping_zone option[value=\'' + zone + '\']').prop('selected', true);
					$('#shipping_zone').trigger('chosen:updated');
				}
			}
		});
		
		$('body').on('blur', '#shipping_zone_chosen ul.chosen-choices li.search-field input', function () {
			var zone = $(this).val().replace(',', '');
			var valid = ValidateZone(zone);
			if ('yes' == valid) {
				$('<option/>', { value: zone, text: zone }).appendTo('#shipping_zone');
				$('#shipping_zone option[value=\'' + zone + '\']').prop('selected', true);
				$('#shipping_zone').trigger('chosen:updated');
			}
		});
		
		userrole = [];
		
		// chossen zone end
		
		// Chosen userrole Start
		configuserrole = {
			'.chosen-select-userrole': {},
			'.chosen-select-deselect': { allow_single_deselect: true }, // eslint-disable-line
			'.chosen-select-no-single': { disable_search_threshold: 10 }, // eslint-disable-line
			'.chosen-select-no-results': { no_results_text: 'Oops, nothing found!' }, // eslint-disable-line
			'.chosen-select-width': { width: '95%' },
		};
		for (selectoruserrole in configuserrole) {
			$(selectoruserrole).chosen(configuserrole[selectoruserrole]);
		}
		selectedUserroleArray = localize_json_output.getUserroleOption.userrolearray;
		selectedUserroleArray = $.parseJSON(selectedUserroleArray);
		
		//console.log(selectedUserroleArray);
		
		selectedUserroleglobalarr = [];
		for (t in selectedUserroleArray) {
			selectedUserroleglobalarr.push(selectedUserroleArray[t]);
		}
		userroleString = '';
		userroleString = selectedUserroleglobalarr.join(',');
		if ('' != userroleString) {
			$.each(userroleString.split(','), function (i, e) {
				$('#userrole option[value=\'' + e + '\']').prop('selected', true);
				$('#userrole').trigger('chosen:updated');
			});
		}
		$('body').on('keyup', '#userrole_chosen ul.chosen-choices li.search-field input', function (evt) {
			var c = evt.keyCode;
			var valid,
				userrole;
			if (188 == c || 13 == c || 59 == c || 186 == c) {
				if (13 == c) {
					userrole = $(this).val();
				}
				if (186 == c) {
					userrole = $(this).val().replace(';', '');
				}
				if (59 == c) {
					userrole = $(this).val().replace(';', '');
				}
				if (188 == c) {
					userrole = $(this).val().replace(',', '');
				}
				valid = ValidateUserRole(userrole);
				if ('yes' == valid) {
					$('<option/>', { value: userrole, text: userrole }).appendTo('#userrole');
					$('#userrole option[value=\'' + userrole + '\']').prop('selected', true);
					$('#userrole').trigger('chosen:updated');
				}
			}
		});
		
		$('body').on('blur', '#userrole_chosen ul.chosen-choices li.search-field input', function () {
			var userrole = $(this).val().replace(',', '');
			var valid = ValidateZip(userrole);
			if ('yes' == valid) {
				$('<option/>', { value: userrole, text: userrole }).appendTo('#userrole');
				$('#userrole option[value=\'' + userrole + '\']').prop('selected', true);
				$('#userrole').trigger('chosen:updated');
			}
		});
		$('#file').change(function () {
			var ext = $('#file').val().split('.').pop().toLowerCase();
			if (-1 == $.inArray(ext, ['xlsx'])) {
				wcbluShowNotification('fa fa-warning', 'Error', 'invalid extension!', 'error');
				wcbluHideNotification();
				$('#file').val('');
			}
		});
		$('#file_state').change(function () {
			var ext = $('#file_state').val().split('.').pop().toLowerCase();
			if (-1 == $.inArray(ext, ['xlsx'])) {
				wcbluShowNotification('fa fa-warning', 'Error', 'invalid extension!', 'error');
				wcbluHideNotification();
				$('#file_state').val('');
			}
		});
		$('#file_zipcode').change(function () {
			var ext = $('#file_zipcode').val().split('.').pop().toLowerCase();
			if (-1 == $.inArray(ext, ['xlsx'])) {
				wcbluShowNotification('fa fa-warning', 'Error', 'invalid extension!', 'error');
				wcbluHideNotification();
				$('#file_zipcode').val('');
			}
		});
		
		$(document).on('click', '#wcblu_import_setting', function () {
			var _uploadedFileValue = $('input[name="import_file"]').val();
			var _uploadedFileExt = _uploadedFileValue.split('.').pop().toLowerCase();
			if ('' === _uploadedFileExt) {
				wcbluShowNotification('fa fa-warning', 'Error', 'Please add file for upload.', 'error');
				wcbluHideNotification();
				return false;
			} else if (-1 == $.inArray(_uploadedFileExt, ['json'])) {
				wcbluShowNotification('fa fa-warning', 'Error', 'Please upload only .json file.', 'error');
				wcbluHideNotification();
				return false;
			}
		});
		
		$(document).on('click', '#migrate_data', function () {
			$.ajax({
				url: adminajax.ajaxurl,
				type: 'post',
				data: {
					action: 'wcblu_fetch_setting',
				},
				success: function (html) {
					location.reload(true);
				},
			});
		});
		
		$(document).on('click', '#all_chk_selection', function () {
			var matches = /\[(.*?)\]/g.exec($(this).attr('name'));
			if ($(this).prop('checked') == true) {
				$('#' + matches[1] + ' option').prop('selected', true);
				$('#' + matches[1]).trigger('chosen:updated');
			} else {
				$('#' + matches[1] + ' option').prop('selected', false);
				$('#' + matches[1]).trigger('chosen:updated');
			}
		});
		
		dotStoreNeededJs();
	});
	
	function dotStoreNeededJs () {
		$('#toplevel_page_woocommerce_blacklist_users').addClass('wp-has-current-submenu wp-menu-open menu-top menu-top-first').removeClass('wp-not-current-submenu');
		$('#toplevel_page_woocommerce_blacklist_users > a').addClass('wp-has-current-submenu current').removeClass('wp-not-current-submenu');
		$('#toplevel_page_dots_store').addClass('wp-has-current-submenu wp-menu-open menu-top menu-top-first').removeClass('wp-not-current-submenu');
		$('#toplevel_page_dots_store > a').addClass('wp-has-current-submenu current').removeClass('wp-not-current-submenu');
		$('li#menu-posts').removeClass('wp-not-current-submenu wp-has-current-submenu wp-menu-open current');
		$('li.mine').css('display', 'none');
		$('li.publish').css('display', 'none');
		$('a[href="admin.php?page=woocommerce_blacklist_users"]').parent().addClass('current');
		$('a[href="admin.php?page=woocommerce_blacklist_users"]').addClass('current');
	}
	
	/**
	 * Function defined to show the notification.
	 *
	 * @param iconClass
	 * @param headerText
	 * @param message
	 * @param successOrError
	 */
	function wcbluShowNotification (iconClass, headerText, message, successOrError) {
		
		$('.notification_popup .notification_icon i').removeClass().addClass(iconClass);
		$('.notification_popup .notification_message h3').text(headerText);
		$('.notification_popup .notification_message p').text(message);
		$('.notification_popup').removeClass('is-success is-error');
		if ('error' === successOrError) {
			$('.notification_popup').addClass('active is-error');
		} else if ('success' === successOrError) {
			$('.notification_popup').addClass('active is-success');
			
		}
		
	}
	
	/**
	 * Function to return hide error notification
	 */
	function wcbluHideNotification () {
		setTimeout(function () {
			$('.notification_popup').removeClass('active');
		}, 3000);
	}
	
	function ValidateIPaddress (ipaddress) {
		
		var ipFormat = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
		
		//check that all the ip in range or without is match or not
		$.each(ipaddress.split('-'), function (i, e) {
			if (!( ipaddress.match(ipFormat) )) {
				return 'no';
			}
		});
		
		//If no any un matched IP found the return yes for IP address is valid
		return 'yes';
	}
	
	function ValidateZip (zip) {
		var zipFormat = /^\d{3,7}$/;
		if (!( zip.match(zipFormat) )) {
			return 'no';
		} else {
			return 'yes';
		}
	}
	
	function ValidateZone (zone) {
		if ('' != zone) {
			return 'no';
		} else {
			return 'yes';
		}
	}
	
	function ValidateUserRole (userrole) {
		if ('' != userrole) {
			return 'no';
		} else {
			return 'yes';
		}
	}
	
	function ValidateEmail (email) {
		var emailFormat = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/; // eslint-disable-line
		if (!( email.match(emailFormat) )) {
			return 'no';
		} else {
			return 'yes';
		}
	}
	
	function ValidateState (state) {
		var stateFormat = /^(A[LKSZRAEP]|C[AOT]|D[EC]|F[LM]|G[ANU]|HI|I[ADLN]|K[SY]|LA|M[ADEHINOPST]|N[CDEHJMVY]|O[HKR]|P[ARW]|RI|S[CD]|T[NX]|UT|V[AIT]|W[AIVY])$/;
		if (!( state.match(stateFormat) )) {
			return 'no';
		} else {
			return 'yes';
		}
	}
	
	function ajaxindicatorstart (text) {
		var firstDiv,
			firstInnerDiv,
			subDiv;
		if ('resultLoading' != $('body').find('#resultLoading').attr('id')) {
			firstDiv = $('<div/>', { id: 'resultLoading', style: 'display:none' }).appendTo('body');
			firstInnerDiv = $('<div/>').appendTo(firstDiv);
			$('<img/>', { src: adminajax.ajax_icon }).appendTo(firstInnerDiv);
			subDiv = $('<div/>').appendTo(firstInnerDiv);
			$('<span/>', { id: '', text: text }).appendTo(subDiv);
			$('<div/>', { class: 'bg' }).appendTo(firstDiv);
		} else {
			$('#ajax-quote').text(text);
		}
		
		$('#resultLoading').css({
			'width': '100%',
			'height': '100%',
			'position': 'fixed',
			'z-index': '10000000',
			'top': '0',
			'left': '0',
			'right': '0',
			'bottom': '0',
			'margin': 'auto',
		});
		$('#resultLoading .bg').css({
			'background': '#000000',
			'opacity': '0.7',
			'width': '100%',
			'height': '100%',
			'position': 'absolute',
			'top': '0',
		});
		$('#resultLoading>div:first').css({
			'width': '250px',
			'height': '75px',
			'text-align': 'center',
			'position': 'fixed',
			'top': '0',
			'left': '0',
			'right': '0',
			'bottom': '0',
			'margin': 'auto',
			'font-size': '16px',
			'z-index': '10',
			'color': '#ffffff',
		});
		$('#resultLoading .bg').height('100%');
		$('#resultLoading').fadeIn(300);
		$('body').css('cursor', 'wait');
		
	}
	
	function ajaxindicatorstop () {
		$('#resultLoading .bg').height('100%');
		$('#resultLoading').fadeOut(300);
		$('body').css('cursor', 'default');
	}
	
} )(jQuery);
